package user

// 玩家账户表
type UserResources struct {
	UID     int64 `gorm:"uniqueIndex" json:"id"`
	Gold    int64 `gorm:"default:0" json:"gold"`    // 金币
	Diamond int64 `gorm:"default:0" json:"diamond"` // 钻石
}

func (u UserResources) GetId() int64 {
	return u.UID
}

func (u UserResources) TableName() string {
	return "user_resources"
}
