package server

import (
	"game/common/proto/pb"
	"github.com/fox/fox/processor"
	"time"
)

const (
	timeout = time.Second * 30
)

func (s *MatchService) initProcessor() {
	s.processor.RegisterMessages(processor.RegisterMetas{
		pb.MsgId_C2SMatchRoomId: {pb.C2SMatchRoom{}, s.onMatchRoom},
	})
}
